/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the JsonSchema type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JsonSchema{}

// JsonSchema struct for JsonSchema
type JsonSchema struct {
	Schema                    NullableString                 `json:"$schema,omitempty"`
	Id                        NullableString                 `json:"id,omitempty"`
	Title                     NullableString                 `json:"title,omitempty"`
	Type                      interface{}                    `json:"type,omitempty"`
	Discriminator             interface{}                    `json:"discriminator,omitempty"`
	Description               NullableString                 `json:"description,omitempty"`
	Format                    NullableString                 `json:"format,omitempty"`
	Default                   interface{}                    `json:"default,omitempty"`
	MultipleOf                NullableFloat64                `json:"multipleOf,omitempty"`
	Maximum                   NullableFloat64                `json:"maximum,omitempty"`
	Minimum                   NullableFloat64                `json:"minimum,omitempty"`
	MaxLength                 NullableInt32                  `json:"maxLength,omitempty"`
	MinLength                 NullableInt32                  `json:"minLength,omitempty"`
	Pattern                   NullableString                 `json:"pattern,omitempty"`
	MaxItems                  *int32                         `json:"maxItems,omitempty"`
	MinItems                  *int32                         `json:"minItems,omitempty"`
	UniqueItems               *bool                          `json:"uniqueItems,omitempty"`
	MaxProperties             *int32                         `json:"maxProperties,omitempty"`
	MinProperties             *int32                         `json:"minProperties,omitempty"`
	XDeprecated               *bool                          `json:"x-deprecated,omitempty"`
	XDeprecatedMessage        NullableString                 `json:"x-deprecatedMessage,omitempty"`
	XAbstract                 *bool                          `json:"x-abstract,omitempty"`
	XNullable                 NullableBool                   `json:"x-nullable,omitempty"`
	XExample                  interface{}                    `json:"x-example,omitempty"`
	XEnumFlags                *bool                          `json:"x-enumFlags,omitempty"`
	XDictionaryKey            *JsonSchema                    `json:"x-dictionaryKey,omitempty"`
	Xml                       *JsonXmlObject                 `json:"xml,omitempty"`
	Not                       *JsonSchema                    `json:"not,omitempty"`
	ExclusiveMaximum          interface{}                    `json:"exclusiveMaximum,omitempty"`
	ExclusiveMinimum          interface{}                    `json:"exclusiveMinimum,omitempty"`
	AdditionalItems           interface{}                    `json:"additionalItems,omitempty"`
	AdditionalPropertiesField interface{}                    `json:"additionalProperties,omitempty"`
	Items                     interface{}                    `json:"items,omitempty"`
	Required                  []string                       `json:"required,omitempty"`
	Properties                *map[string]JsonSchemaProperty `json:"properties,omitempty"`
	PatternProperties         *map[string]JsonSchemaProperty `json:"patternProperties,omitempty"`
	Definitions               *map[string]JsonSchema         `json:"definitions,omitempty"`
	XEnumNames                []string                       `json:"x-enumNames,omitempty"`
	Enum                      []interface{}                  `json:"enum,omitempty"`
	AllOf                     []JsonSchema                   `json:"allOf,omitempty"`
	AnyOf                     []JsonSchema                   `json:"anyOf,omitempty"`
	OneOf                     []JsonSchema                   `json:"oneOf,omitempty"`
	Ref                       *string                        `json:"$ref,omitempty"`
	AdditionalProperties      map[string]interface{}
}

type _JsonSchema JsonSchema

// NewJsonSchema instantiates a new JsonSchema object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJsonSchema() *JsonSchema {
	this := JsonSchema{}
	return &this
}

// NewJsonSchemaWithDefaults instantiates a new JsonSchema object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJsonSchemaWithDefaults() *JsonSchema {
	this := JsonSchema{}
	return &this
}

// GetSchema returns the Schema field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetSchema() string {
	if o == nil || IsNil(o.Schema.Get()) {
		var ret string
		return ret
	}
	return *o.Schema.Get()
}

// GetSchemaOk returns a tuple with the Schema field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetSchemaOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Schema.Get(), o.Schema.IsSet()
}

// HasSchema returns a boolean if a field has been set.
func (o *JsonSchema) HasSchema() bool {
	if o != nil && o.Schema.IsSet() {
		return true
	}

	return false
}

// SetSchema gets a reference to the given NullableString and assigns it to the Schema field.
func (o *JsonSchema) SetSchema(v string) {
	o.Schema.Set(&v)
}

// SetSchemaNil sets the value for Schema to be an explicit nil
func (o *JsonSchema) SetSchemaNil() {
	o.Schema.Set(nil)
}

// UnsetSchema ensures that no value is present for Schema, not even an explicit nil
func (o *JsonSchema) UnsetSchema() {
	o.Schema.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *JsonSchema) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *JsonSchema) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *JsonSchema) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *JsonSchema) UnsetId() {
	o.Id.Unset()
}

// GetTitle returns the Title field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetTitle() string {
	if o == nil || IsNil(o.Title.Get()) {
		var ret string
		return ret
	}
	return *o.Title.Get()
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetTitleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Title.Get(), o.Title.IsSet()
}

// HasTitle returns a boolean if a field has been set.
func (o *JsonSchema) HasTitle() bool {
	if o != nil && o.Title.IsSet() {
		return true
	}

	return false
}

// SetTitle gets a reference to the given NullableString and assigns it to the Title field.
func (o *JsonSchema) SetTitle(v string) {
	o.Title.Set(&v)
}

// SetTitleNil sets the value for Title to be an explicit nil
func (o *JsonSchema) SetTitleNil() {
	o.Title.Set(nil)
}

// UnsetTitle ensures that no value is present for Title, not even an explicit nil
func (o *JsonSchema) UnsetTitle() {
	o.Title.Unset()
}

// GetType returns the Type field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetType() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetTypeOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return &o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *JsonSchema) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given interface{} and assigns it to the Type field.
func (o *JsonSchema) SetType(v interface{}) {
	o.Type = v
}

// GetDiscriminator returns the Discriminator field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetDiscriminator() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Discriminator
}

// GetDiscriminatorOk returns a tuple with the Discriminator field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetDiscriminatorOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Discriminator) {
		return nil, false
	}
	return &o.Discriminator, true
}

// HasDiscriminator returns a boolean if a field has been set.
func (o *JsonSchema) HasDiscriminator() bool {
	if o != nil && !IsNil(o.Discriminator) {
		return true
	}

	return false
}

// SetDiscriminator gets a reference to the given interface{} and assigns it to the Discriminator field.
func (o *JsonSchema) SetDiscriminator(v interface{}) {
	o.Discriminator = v
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *JsonSchema) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *JsonSchema) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *JsonSchema) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *JsonSchema) UnsetDescription() {
	o.Description.Unset()
}

// GetFormat returns the Format field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetFormat() string {
	if o == nil || IsNil(o.Format.Get()) {
		var ret string
		return ret
	}
	return *o.Format.Get()
}

// GetFormatOk returns a tuple with the Format field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetFormatOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Format.Get(), o.Format.IsSet()
}

// HasFormat returns a boolean if a field has been set.
func (o *JsonSchema) HasFormat() bool {
	if o != nil && o.Format.IsSet() {
		return true
	}

	return false
}

// SetFormat gets a reference to the given NullableString and assigns it to the Format field.
func (o *JsonSchema) SetFormat(v string) {
	o.Format.Set(&v)
}

// SetFormatNil sets the value for Format to be an explicit nil
func (o *JsonSchema) SetFormatNil() {
	o.Format.Set(nil)
}

// UnsetFormat ensures that no value is present for Format, not even an explicit nil
func (o *JsonSchema) UnsetFormat() {
	o.Format.Unset()
}

// GetDefault returns the Default field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetDefault() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Default
}

// GetDefaultOk returns a tuple with the Default field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetDefaultOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Default) {
		return nil, false
	}
	return &o.Default, true
}

// HasDefault returns a boolean if a field has been set.
func (o *JsonSchema) HasDefault() bool {
	if o != nil && !IsNil(o.Default) {
		return true
	}

	return false
}

// SetDefault gets a reference to the given interface{} and assigns it to the Default field.
func (o *JsonSchema) SetDefault(v interface{}) {
	o.Default = v
}

// GetMultipleOf returns the MultipleOf field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetMultipleOf() float64 {
	if o == nil || IsNil(o.MultipleOf.Get()) {
		var ret float64
		return ret
	}
	return *o.MultipleOf.Get()
}

// GetMultipleOfOk returns a tuple with the MultipleOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetMultipleOfOk() (*float64, bool) {
	if o == nil {
		return nil, false
	}
	return o.MultipleOf.Get(), o.MultipleOf.IsSet()
}

// HasMultipleOf returns a boolean if a field has been set.
func (o *JsonSchema) HasMultipleOf() bool {
	if o != nil && o.MultipleOf.IsSet() {
		return true
	}

	return false
}

// SetMultipleOf gets a reference to the given NullableFloat64 and assigns it to the MultipleOf field.
func (o *JsonSchema) SetMultipleOf(v float64) {
	o.MultipleOf.Set(&v)
}

// SetMultipleOfNil sets the value for MultipleOf to be an explicit nil
func (o *JsonSchema) SetMultipleOfNil() {
	o.MultipleOf.Set(nil)
}

// UnsetMultipleOf ensures that no value is present for MultipleOf, not even an explicit nil
func (o *JsonSchema) UnsetMultipleOf() {
	o.MultipleOf.Unset()
}

// GetMaximum returns the Maximum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetMaximum() float64 {
	if o == nil || IsNil(o.Maximum.Get()) {
		var ret float64
		return ret
	}
	return *o.Maximum.Get()
}

// GetMaximumOk returns a tuple with the Maximum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetMaximumOk() (*float64, bool) {
	if o == nil {
		return nil, false
	}
	return o.Maximum.Get(), o.Maximum.IsSet()
}

// HasMaximum returns a boolean if a field has been set.
func (o *JsonSchema) HasMaximum() bool {
	if o != nil && o.Maximum.IsSet() {
		return true
	}

	return false
}

// SetMaximum gets a reference to the given NullableFloat64 and assigns it to the Maximum field.
func (o *JsonSchema) SetMaximum(v float64) {
	o.Maximum.Set(&v)
}

// SetMaximumNil sets the value for Maximum to be an explicit nil
func (o *JsonSchema) SetMaximumNil() {
	o.Maximum.Set(nil)
}

// UnsetMaximum ensures that no value is present for Maximum, not even an explicit nil
func (o *JsonSchema) UnsetMaximum() {
	o.Maximum.Unset()
}

// GetMinimum returns the Minimum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetMinimum() float64 {
	if o == nil || IsNil(o.Minimum.Get()) {
		var ret float64
		return ret
	}
	return *o.Minimum.Get()
}

// GetMinimumOk returns a tuple with the Minimum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetMinimumOk() (*float64, bool) {
	if o == nil {
		return nil, false
	}
	return o.Minimum.Get(), o.Minimum.IsSet()
}

// HasMinimum returns a boolean if a field has been set.
func (o *JsonSchema) HasMinimum() bool {
	if o != nil && o.Minimum.IsSet() {
		return true
	}

	return false
}

// SetMinimum gets a reference to the given NullableFloat64 and assigns it to the Minimum field.
func (o *JsonSchema) SetMinimum(v float64) {
	o.Minimum.Set(&v)
}

// SetMinimumNil sets the value for Minimum to be an explicit nil
func (o *JsonSchema) SetMinimumNil() {
	o.Minimum.Set(nil)
}

// UnsetMinimum ensures that no value is present for Minimum, not even an explicit nil
func (o *JsonSchema) UnsetMinimum() {
	o.Minimum.Unset()
}

// GetMaxLength returns the MaxLength field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetMaxLength() int32 {
	if o == nil || IsNil(o.MaxLength.Get()) {
		var ret int32
		return ret
	}
	return *o.MaxLength.Get()
}

// GetMaxLengthOk returns a tuple with the MaxLength field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetMaxLengthOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.MaxLength.Get(), o.MaxLength.IsSet()
}

// HasMaxLength returns a boolean if a field has been set.
func (o *JsonSchema) HasMaxLength() bool {
	if o != nil && o.MaxLength.IsSet() {
		return true
	}

	return false
}

// SetMaxLength gets a reference to the given NullableInt32 and assigns it to the MaxLength field.
func (o *JsonSchema) SetMaxLength(v int32) {
	o.MaxLength.Set(&v)
}

// SetMaxLengthNil sets the value for MaxLength to be an explicit nil
func (o *JsonSchema) SetMaxLengthNil() {
	o.MaxLength.Set(nil)
}

// UnsetMaxLength ensures that no value is present for MaxLength, not even an explicit nil
func (o *JsonSchema) UnsetMaxLength() {
	o.MaxLength.Unset()
}

// GetMinLength returns the MinLength field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetMinLength() int32 {
	if o == nil || IsNil(o.MinLength.Get()) {
		var ret int32
		return ret
	}
	return *o.MinLength.Get()
}

// GetMinLengthOk returns a tuple with the MinLength field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetMinLengthOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.MinLength.Get(), o.MinLength.IsSet()
}

// HasMinLength returns a boolean if a field has been set.
func (o *JsonSchema) HasMinLength() bool {
	if o != nil && o.MinLength.IsSet() {
		return true
	}

	return false
}

// SetMinLength gets a reference to the given NullableInt32 and assigns it to the MinLength field.
func (o *JsonSchema) SetMinLength(v int32) {
	o.MinLength.Set(&v)
}

// SetMinLengthNil sets the value for MinLength to be an explicit nil
func (o *JsonSchema) SetMinLengthNil() {
	o.MinLength.Set(nil)
}

// UnsetMinLength ensures that no value is present for MinLength, not even an explicit nil
func (o *JsonSchema) UnsetMinLength() {
	o.MinLength.Unset()
}

// GetPattern returns the Pattern field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetPattern() string {
	if o == nil || IsNil(o.Pattern.Get()) {
		var ret string
		return ret
	}
	return *o.Pattern.Get()
}

// GetPatternOk returns a tuple with the Pattern field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetPatternOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Pattern.Get(), o.Pattern.IsSet()
}

// HasPattern returns a boolean if a field has been set.
func (o *JsonSchema) HasPattern() bool {
	if o != nil && o.Pattern.IsSet() {
		return true
	}

	return false
}

// SetPattern gets a reference to the given NullableString and assigns it to the Pattern field.
func (o *JsonSchema) SetPattern(v string) {
	o.Pattern.Set(&v)
}

// SetPatternNil sets the value for Pattern to be an explicit nil
func (o *JsonSchema) SetPatternNil() {
	o.Pattern.Set(nil)
}

// UnsetPattern ensures that no value is present for Pattern, not even an explicit nil
func (o *JsonSchema) UnsetPattern() {
	o.Pattern.Unset()
}

// GetMaxItems returns the MaxItems field value if set, zero value otherwise.
func (o *JsonSchema) GetMaxItems() int32 {
	if o == nil || IsNil(o.MaxItems) {
		var ret int32
		return ret
	}
	return *o.MaxItems
}

// GetMaxItemsOk returns a tuple with the MaxItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetMaxItemsOk() (*int32, bool) {
	if o == nil || IsNil(o.MaxItems) {
		return nil, false
	}
	return o.MaxItems, true
}

// HasMaxItems returns a boolean if a field has been set.
func (o *JsonSchema) HasMaxItems() bool {
	if o != nil && !IsNil(o.MaxItems) {
		return true
	}

	return false
}

// SetMaxItems gets a reference to the given int32 and assigns it to the MaxItems field.
func (o *JsonSchema) SetMaxItems(v int32) {
	o.MaxItems = &v
}

// GetMinItems returns the MinItems field value if set, zero value otherwise.
func (o *JsonSchema) GetMinItems() int32 {
	if o == nil || IsNil(o.MinItems) {
		var ret int32
		return ret
	}
	return *o.MinItems
}

// GetMinItemsOk returns a tuple with the MinItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetMinItemsOk() (*int32, bool) {
	if o == nil || IsNil(o.MinItems) {
		return nil, false
	}
	return o.MinItems, true
}

// HasMinItems returns a boolean if a field has been set.
func (o *JsonSchema) HasMinItems() bool {
	if o != nil && !IsNil(o.MinItems) {
		return true
	}

	return false
}

// SetMinItems gets a reference to the given int32 and assigns it to the MinItems field.
func (o *JsonSchema) SetMinItems(v int32) {
	o.MinItems = &v
}

// GetUniqueItems returns the UniqueItems field value if set, zero value otherwise.
func (o *JsonSchema) GetUniqueItems() bool {
	if o == nil || IsNil(o.UniqueItems) {
		var ret bool
		return ret
	}
	return *o.UniqueItems
}

// GetUniqueItemsOk returns a tuple with the UniqueItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetUniqueItemsOk() (*bool, bool) {
	if o == nil || IsNil(o.UniqueItems) {
		return nil, false
	}
	return o.UniqueItems, true
}

// HasUniqueItems returns a boolean if a field has been set.
func (o *JsonSchema) HasUniqueItems() bool {
	if o != nil && !IsNil(o.UniqueItems) {
		return true
	}

	return false
}

// SetUniqueItems gets a reference to the given bool and assigns it to the UniqueItems field.
func (o *JsonSchema) SetUniqueItems(v bool) {
	o.UniqueItems = &v
}

// GetMaxProperties returns the MaxProperties field value if set, zero value otherwise.
func (o *JsonSchema) GetMaxProperties() int32 {
	if o == nil || IsNil(o.MaxProperties) {
		var ret int32
		return ret
	}
	return *o.MaxProperties
}

// GetMaxPropertiesOk returns a tuple with the MaxProperties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetMaxPropertiesOk() (*int32, bool) {
	if o == nil || IsNil(o.MaxProperties) {
		return nil, false
	}
	return o.MaxProperties, true
}

// HasMaxProperties returns a boolean if a field has been set.
func (o *JsonSchema) HasMaxProperties() bool {
	if o != nil && !IsNil(o.MaxProperties) {
		return true
	}

	return false
}

// SetMaxProperties gets a reference to the given int32 and assigns it to the MaxProperties field.
func (o *JsonSchema) SetMaxProperties(v int32) {
	o.MaxProperties = &v
}

// GetMinProperties returns the MinProperties field value if set, zero value otherwise.
func (o *JsonSchema) GetMinProperties() int32 {
	if o == nil || IsNil(o.MinProperties) {
		var ret int32
		return ret
	}
	return *o.MinProperties
}

// GetMinPropertiesOk returns a tuple with the MinProperties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetMinPropertiesOk() (*int32, bool) {
	if o == nil || IsNil(o.MinProperties) {
		return nil, false
	}
	return o.MinProperties, true
}

// HasMinProperties returns a boolean if a field has been set.
func (o *JsonSchema) HasMinProperties() bool {
	if o != nil && !IsNil(o.MinProperties) {
		return true
	}

	return false
}

// SetMinProperties gets a reference to the given int32 and assigns it to the MinProperties field.
func (o *JsonSchema) SetMinProperties(v int32) {
	o.MinProperties = &v
}

// GetXDeprecated returns the XDeprecated field value if set, zero value otherwise.
func (o *JsonSchema) GetXDeprecated() bool {
	if o == nil || IsNil(o.XDeprecated) {
		var ret bool
		return ret
	}
	return *o.XDeprecated
}

// GetXDeprecatedOk returns a tuple with the XDeprecated field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetXDeprecatedOk() (*bool, bool) {
	if o == nil || IsNil(o.XDeprecated) {
		return nil, false
	}
	return o.XDeprecated, true
}

// HasXDeprecated returns a boolean if a field has been set.
func (o *JsonSchema) HasXDeprecated() bool {
	if o != nil && !IsNil(o.XDeprecated) {
		return true
	}

	return false
}

// SetXDeprecated gets a reference to the given bool and assigns it to the XDeprecated field.
func (o *JsonSchema) SetXDeprecated(v bool) {
	o.XDeprecated = &v
}

// GetXDeprecatedMessage returns the XDeprecatedMessage field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetXDeprecatedMessage() string {
	if o == nil || IsNil(o.XDeprecatedMessage.Get()) {
		var ret string
		return ret
	}
	return *o.XDeprecatedMessage.Get()
}

// GetXDeprecatedMessageOk returns a tuple with the XDeprecatedMessage field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetXDeprecatedMessageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.XDeprecatedMessage.Get(), o.XDeprecatedMessage.IsSet()
}

// HasXDeprecatedMessage returns a boolean if a field has been set.
func (o *JsonSchema) HasXDeprecatedMessage() bool {
	if o != nil && o.XDeprecatedMessage.IsSet() {
		return true
	}

	return false
}

// SetXDeprecatedMessage gets a reference to the given NullableString and assigns it to the XDeprecatedMessage field.
func (o *JsonSchema) SetXDeprecatedMessage(v string) {
	o.XDeprecatedMessage.Set(&v)
}

// SetXDeprecatedMessageNil sets the value for XDeprecatedMessage to be an explicit nil
func (o *JsonSchema) SetXDeprecatedMessageNil() {
	o.XDeprecatedMessage.Set(nil)
}

// UnsetXDeprecatedMessage ensures that no value is present for XDeprecatedMessage, not even an explicit nil
func (o *JsonSchema) UnsetXDeprecatedMessage() {
	o.XDeprecatedMessage.Unset()
}

// GetXAbstract returns the XAbstract field value if set, zero value otherwise.
func (o *JsonSchema) GetXAbstract() bool {
	if o == nil || IsNil(o.XAbstract) {
		var ret bool
		return ret
	}
	return *o.XAbstract
}

// GetXAbstractOk returns a tuple with the XAbstract field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetXAbstractOk() (*bool, bool) {
	if o == nil || IsNil(o.XAbstract) {
		return nil, false
	}
	return o.XAbstract, true
}

// HasXAbstract returns a boolean if a field has been set.
func (o *JsonSchema) HasXAbstract() bool {
	if o != nil && !IsNil(o.XAbstract) {
		return true
	}

	return false
}

// SetXAbstract gets a reference to the given bool and assigns it to the XAbstract field.
func (o *JsonSchema) SetXAbstract(v bool) {
	o.XAbstract = &v
}

// GetXNullable returns the XNullable field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetXNullable() bool {
	if o == nil || IsNil(o.XNullable.Get()) {
		var ret bool
		return ret
	}
	return *o.XNullable.Get()
}

// GetXNullableOk returns a tuple with the XNullable field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetXNullableOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return o.XNullable.Get(), o.XNullable.IsSet()
}

// HasXNullable returns a boolean if a field has been set.
func (o *JsonSchema) HasXNullable() bool {
	if o != nil && o.XNullable.IsSet() {
		return true
	}

	return false
}

// SetXNullable gets a reference to the given NullableBool and assigns it to the XNullable field.
func (o *JsonSchema) SetXNullable(v bool) {
	o.XNullable.Set(&v)
}

// SetXNullableNil sets the value for XNullable to be an explicit nil
func (o *JsonSchema) SetXNullableNil() {
	o.XNullable.Set(nil)
}

// UnsetXNullable ensures that no value is present for XNullable, not even an explicit nil
func (o *JsonSchema) UnsetXNullable() {
	o.XNullable.Unset()
}

// GetXExample returns the XExample field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetXExample() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.XExample
}

// GetXExampleOk returns a tuple with the XExample field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetXExampleOk() (*interface{}, bool) {
	if o == nil || IsNil(o.XExample) {
		return nil, false
	}
	return &o.XExample, true
}

// HasXExample returns a boolean if a field has been set.
func (o *JsonSchema) HasXExample() bool {
	if o != nil && !IsNil(o.XExample) {
		return true
	}

	return false
}

// SetXExample gets a reference to the given interface{} and assigns it to the XExample field.
func (o *JsonSchema) SetXExample(v interface{}) {
	o.XExample = v
}

// GetXEnumFlags returns the XEnumFlags field value if set, zero value otherwise.
func (o *JsonSchema) GetXEnumFlags() bool {
	if o == nil || IsNil(o.XEnumFlags) {
		var ret bool
		return ret
	}
	return *o.XEnumFlags
}

// GetXEnumFlagsOk returns a tuple with the XEnumFlags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetXEnumFlagsOk() (*bool, bool) {
	if o == nil || IsNil(o.XEnumFlags) {
		return nil, false
	}
	return o.XEnumFlags, true
}

// HasXEnumFlags returns a boolean if a field has been set.
func (o *JsonSchema) HasXEnumFlags() bool {
	if o != nil && !IsNil(o.XEnumFlags) {
		return true
	}

	return false
}

// SetXEnumFlags gets a reference to the given bool and assigns it to the XEnumFlags field.
func (o *JsonSchema) SetXEnumFlags(v bool) {
	o.XEnumFlags = &v
}

// GetXDictionaryKey returns the XDictionaryKey field value if set, zero value otherwise.
func (o *JsonSchema) GetXDictionaryKey() JsonSchema {
	if o == nil || IsNil(o.XDictionaryKey) {
		var ret JsonSchema
		return ret
	}
	return *o.XDictionaryKey
}

// GetXDictionaryKeyOk returns a tuple with the XDictionaryKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetXDictionaryKeyOk() (*JsonSchema, bool) {
	if o == nil || IsNil(o.XDictionaryKey) {
		return nil, false
	}
	return o.XDictionaryKey, true
}

// HasXDictionaryKey returns a boolean if a field has been set.
func (o *JsonSchema) HasXDictionaryKey() bool {
	if o != nil && !IsNil(o.XDictionaryKey) {
		return true
	}

	return false
}

// SetXDictionaryKey gets a reference to the given JsonSchema and assigns it to the XDictionaryKey field.
func (o *JsonSchema) SetXDictionaryKey(v JsonSchema) {
	o.XDictionaryKey = &v
}

// GetXml returns the Xml field value if set, zero value otherwise.
func (o *JsonSchema) GetXml() JsonXmlObject {
	if o == nil || IsNil(o.Xml) {
		var ret JsonXmlObject
		return ret
	}
	return *o.Xml
}

// GetXmlOk returns a tuple with the Xml field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetXmlOk() (*JsonXmlObject, bool) {
	if o == nil || IsNil(o.Xml) {
		return nil, false
	}
	return o.Xml, true
}

// HasXml returns a boolean if a field has been set.
func (o *JsonSchema) HasXml() bool {
	if o != nil && !IsNil(o.Xml) {
		return true
	}

	return false
}

// SetXml gets a reference to the given JsonXmlObject and assigns it to the Xml field.
func (o *JsonSchema) SetXml(v JsonXmlObject) {
	o.Xml = &v
}

// GetNot returns the Not field value if set, zero value otherwise.
func (o *JsonSchema) GetNot() JsonSchema {
	if o == nil || IsNil(o.Not) {
		var ret JsonSchema
		return ret
	}
	return *o.Not
}

// GetNotOk returns a tuple with the Not field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetNotOk() (*JsonSchema, bool) {
	if o == nil || IsNil(o.Not) {
		return nil, false
	}
	return o.Not, true
}

// HasNot returns a boolean if a field has been set.
func (o *JsonSchema) HasNot() bool {
	if o != nil && !IsNil(o.Not) {
		return true
	}

	return false
}

// SetNot gets a reference to the given JsonSchema and assigns it to the Not field.
func (o *JsonSchema) SetNot(v JsonSchema) {
	o.Not = &v
}

// GetExclusiveMaximum returns the ExclusiveMaximum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetExclusiveMaximum() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ExclusiveMaximum
}

// GetExclusiveMaximumOk returns a tuple with the ExclusiveMaximum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetExclusiveMaximumOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ExclusiveMaximum) {
		return nil, false
	}
	return &o.ExclusiveMaximum, true
}

// HasExclusiveMaximum returns a boolean if a field has been set.
func (o *JsonSchema) HasExclusiveMaximum() bool {
	if o != nil && !IsNil(o.ExclusiveMaximum) {
		return true
	}

	return false
}

// SetExclusiveMaximum gets a reference to the given interface{} and assigns it to the ExclusiveMaximum field.
func (o *JsonSchema) SetExclusiveMaximum(v interface{}) {
	o.ExclusiveMaximum = v
}

// GetExclusiveMinimum returns the ExclusiveMinimum field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetExclusiveMinimum() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ExclusiveMinimum
}

// GetExclusiveMinimumOk returns a tuple with the ExclusiveMinimum field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetExclusiveMinimumOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ExclusiveMinimum) {
		return nil, false
	}
	return &o.ExclusiveMinimum, true
}

// HasExclusiveMinimum returns a boolean if a field has been set.
func (o *JsonSchema) HasExclusiveMinimum() bool {
	if o != nil && !IsNil(o.ExclusiveMinimum) {
		return true
	}

	return false
}

// SetExclusiveMinimum gets a reference to the given interface{} and assigns it to the ExclusiveMinimum field.
func (o *JsonSchema) SetExclusiveMinimum(v interface{}) {
	o.ExclusiveMinimum = v
}

// GetAdditionalItems returns the AdditionalItems field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetAdditionalItems() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.AdditionalItems
}

// GetAdditionalItemsOk returns a tuple with the AdditionalItems field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetAdditionalItemsOk() (*interface{}, bool) {
	if o == nil || IsNil(o.AdditionalItems) {
		return nil, false
	}
	return &o.AdditionalItems, true
}

// HasAdditionalItems returns a boolean if a field has been set.
func (o *JsonSchema) HasAdditionalItems() bool {
	if o != nil && !IsNil(o.AdditionalItems) {
		return true
	}

	return false
}

// SetAdditionalItems gets a reference to the given interface{} and assigns it to the AdditionalItems field.
func (o *JsonSchema) SetAdditionalItems(v interface{}) {
	o.AdditionalItems = v
}

// GetAdditionalPropertiesField returns the AdditionalPropertiesField field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetAdditionalPropertiesField() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.AdditionalPropertiesField
}

// GetAdditionalPropertiesFieldOk returns a tuple with the AdditionalPropertiesField field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetAdditionalPropertiesFieldOk() (*interface{}, bool) {
	if o == nil || IsNil(o.AdditionalPropertiesField) {
		return nil, false
	}
	return &o.AdditionalPropertiesField, true
}

// HasAdditionalPropertiesField returns a boolean if a field has been set.
func (o *JsonSchema) HasAdditionalPropertiesField() bool {
	if o != nil && !IsNil(o.AdditionalPropertiesField) {
		return true
	}

	return false
}

// SetAdditionalPropertiesField gets a reference to the given interface{} and assigns it to the AdditionalPropertiesField field.
func (o *JsonSchema) SetAdditionalPropertiesField(v interface{}) {
	o.AdditionalPropertiesField = v
}

// GetItems returns the Items field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonSchema) GetItems() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonSchema) GetItemsOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Items) {
		return nil, false
	}
	return &o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *JsonSchema) HasItems() bool {
	if o != nil && !IsNil(o.Items) {
		return true
	}

	return false
}

// SetItems gets a reference to the given interface{} and assigns it to the Items field.
func (o *JsonSchema) SetItems(v interface{}) {
	o.Items = v
}

// GetRequired returns the Required field value if set, zero value otherwise.
func (o *JsonSchema) GetRequired() []string {
	if o == nil || IsNil(o.Required) {
		var ret []string
		return ret
	}
	return o.Required
}

// GetRequiredOk returns a tuple with the Required field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetRequiredOk() ([]string, bool) {
	if o == nil || IsNil(o.Required) {
		return nil, false
	}
	return o.Required, true
}

// HasRequired returns a boolean if a field has been set.
func (o *JsonSchema) HasRequired() bool {
	if o != nil && !IsNil(o.Required) {
		return true
	}

	return false
}

// SetRequired gets a reference to the given []string and assigns it to the Required field.
func (o *JsonSchema) SetRequired(v []string) {
	o.Required = v
}

// GetProperties returns the Properties field value if set, zero value otherwise.
func (o *JsonSchema) GetProperties() map[string]JsonSchemaProperty {
	if o == nil || IsNil(o.Properties) {
		var ret map[string]JsonSchemaProperty
		return ret
	}
	return *o.Properties
}

// GetPropertiesOk returns a tuple with the Properties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetPropertiesOk() (*map[string]JsonSchemaProperty, bool) {
	if o == nil || IsNil(o.Properties) {
		return nil, false
	}
	return o.Properties, true
}

// HasProperties returns a boolean if a field has been set.
func (o *JsonSchema) HasProperties() bool {
	if o != nil && !IsNil(o.Properties) {
		return true
	}

	return false
}

// SetProperties gets a reference to the given map[string]JsonSchemaProperty and assigns it to the Properties field.
func (o *JsonSchema) SetProperties(v map[string]JsonSchemaProperty) {
	o.Properties = &v
}

// GetPatternProperties returns the PatternProperties field value if set, zero value otherwise.
func (o *JsonSchema) GetPatternProperties() map[string]JsonSchemaProperty {
	if o == nil || IsNil(o.PatternProperties) {
		var ret map[string]JsonSchemaProperty
		return ret
	}
	return *o.PatternProperties
}

// GetPatternPropertiesOk returns a tuple with the PatternProperties field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetPatternPropertiesOk() (*map[string]JsonSchemaProperty, bool) {
	if o == nil || IsNil(o.PatternProperties) {
		return nil, false
	}
	return o.PatternProperties, true
}

// HasPatternProperties returns a boolean if a field has been set.
func (o *JsonSchema) HasPatternProperties() bool {
	if o != nil && !IsNil(o.PatternProperties) {
		return true
	}

	return false
}

// SetPatternProperties gets a reference to the given map[string]JsonSchemaProperty and assigns it to the PatternProperties field.
func (o *JsonSchema) SetPatternProperties(v map[string]JsonSchemaProperty) {
	o.PatternProperties = &v
}

// GetDefinitions returns the Definitions field value if set, zero value otherwise.
func (o *JsonSchema) GetDefinitions() map[string]JsonSchema {
	if o == nil || IsNil(o.Definitions) {
		var ret map[string]JsonSchema
		return ret
	}
	return *o.Definitions
}

// GetDefinitionsOk returns a tuple with the Definitions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetDefinitionsOk() (*map[string]JsonSchema, bool) {
	if o == nil || IsNil(o.Definitions) {
		return nil, false
	}
	return o.Definitions, true
}

// HasDefinitions returns a boolean if a field has been set.
func (o *JsonSchema) HasDefinitions() bool {
	if o != nil && !IsNil(o.Definitions) {
		return true
	}

	return false
}

// SetDefinitions gets a reference to the given map[string]JsonSchema and assigns it to the Definitions field.
func (o *JsonSchema) SetDefinitions(v map[string]JsonSchema) {
	o.Definitions = &v
}

// GetXEnumNames returns the XEnumNames field value if set, zero value otherwise.
func (o *JsonSchema) GetXEnumNames() []string {
	if o == nil || IsNil(o.XEnumNames) {
		var ret []string
		return ret
	}
	return o.XEnumNames
}

// GetXEnumNamesOk returns a tuple with the XEnumNames field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetXEnumNamesOk() ([]string, bool) {
	if o == nil || IsNil(o.XEnumNames) {
		return nil, false
	}
	return o.XEnumNames, true
}

// HasXEnumNames returns a boolean if a field has been set.
func (o *JsonSchema) HasXEnumNames() bool {
	if o != nil && !IsNil(o.XEnumNames) {
		return true
	}

	return false
}

// SetXEnumNames gets a reference to the given []string and assigns it to the XEnumNames field.
func (o *JsonSchema) SetXEnumNames(v []string) {
	o.XEnumNames = v
}

// GetEnum returns the Enum field value if set, zero value otherwise.
func (o *JsonSchema) GetEnum() []interface{} {
	if o == nil || IsNil(o.Enum) {
		var ret []interface{}
		return ret
	}
	return o.Enum
}

// GetEnumOk returns a tuple with the Enum field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetEnumOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Enum) {
		return nil, false
	}
	return o.Enum, true
}

// HasEnum returns a boolean if a field has been set.
func (o *JsonSchema) HasEnum() bool {
	if o != nil && !IsNil(o.Enum) {
		return true
	}

	return false
}

// SetEnum gets a reference to the given []interface{} and assigns it to the Enum field.
func (o *JsonSchema) SetEnum(v []interface{}) {
	o.Enum = v
}

// GetAllOf returns the AllOf field value if set, zero value otherwise.
func (o *JsonSchema) GetAllOf() []JsonSchema {
	if o == nil || IsNil(o.AllOf) {
		var ret []JsonSchema
		return ret
	}
	return o.AllOf
}

// GetAllOfOk returns a tuple with the AllOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetAllOfOk() ([]JsonSchema, bool) {
	if o == nil || IsNil(o.AllOf) {
		return nil, false
	}
	return o.AllOf, true
}

// HasAllOf returns a boolean if a field has been set.
func (o *JsonSchema) HasAllOf() bool {
	if o != nil && !IsNil(o.AllOf) {
		return true
	}

	return false
}

// SetAllOf gets a reference to the given []JsonSchema and assigns it to the AllOf field.
func (o *JsonSchema) SetAllOf(v []JsonSchema) {
	o.AllOf = v
}

// GetAnyOf returns the AnyOf field value if set, zero value otherwise.
func (o *JsonSchema) GetAnyOf() []JsonSchema {
	if o == nil || IsNil(o.AnyOf) {
		var ret []JsonSchema
		return ret
	}
	return o.AnyOf
}

// GetAnyOfOk returns a tuple with the AnyOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetAnyOfOk() ([]JsonSchema, bool) {
	if o == nil || IsNil(o.AnyOf) {
		return nil, false
	}
	return o.AnyOf, true
}

// HasAnyOf returns a boolean if a field has been set.
func (o *JsonSchema) HasAnyOf() bool {
	if o != nil && !IsNil(o.AnyOf) {
		return true
	}

	return false
}

// SetAnyOf gets a reference to the given []JsonSchema and assigns it to the AnyOf field.
func (o *JsonSchema) SetAnyOf(v []JsonSchema) {
	o.AnyOf = v
}

// GetOneOf returns the OneOf field value if set, zero value otherwise.
func (o *JsonSchema) GetOneOf() []JsonSchema {
	if o == nil || IsNil(o.OneOf) {
		var ret []JsonSchema
		return ret
	}
	return o.OneOf
}

// GetOneOfOk returns a tuple with the OneOf field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetOneOfOk() ([]JsonSchema, bool) {
	if o == nil || IsNil(o.OneOf) {
		return nil, false
	}
	return o.OneOf, true
}

// HasOneOf returns a boolean if a field has been set.
func (o *JsonSchema) HasOneOf() bool {
	if o != nil && !IsNil(o.OneOf) {
		return true
	}

	return false
}

// SetOneOf gets a reference to the given []JsonSchema and assigns it to the OneOf field.
func (o *JsonSchema) SetOneOf(v []JsonSchema) {
	o.OneOf = v
}

// GetRef returns the Ref field value if set, zero value otherwise.
func (o *JsonSchema) GetRef() string {
	if o == nil || IsNil(o.Ref) {
		var ret string
		return ret
	}
	return *o.Ref
}

// GetRefOk returns a tuple with the Ref field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JsonSchema) GetRefOk() (*string, bool) {
	if o == nil || IsNil(o.Ref) {
		return nil, false
	}
	return o.Ref, true
}

// HasRef returns a boolean if a field has been set.
func (o *JsonSchema) HasRef() bool {
	if o != nil && !IsNil(o.Ref) {
		return true
	}

	return false
}

// SetRef gets a reference to the given string and assigns it to the Ref field.
func (o *JsonSchema) SetRef(v string) {
	o.Ref = &v
}

func (o JsonSchema) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JsonSchema) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Schema.IsSet() {
		toSerialize["$schema"] = o.Schema.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if o.Title.IsSet() {
		toSerialize["title"] = o.Title.Get()
	}
	if o.Type != nil {
		toSerialize["type"] = o.Type
	}
	if o.Discriminator != nil {
		toSerialize["discriminator"] = o.Discriminator
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.Format.IsSet() {
		toSerialize["format"] = o.Format.Get()
	}
	if o.Default != nil {
		toSerialize["default"] = o.Default
	}
	if o.MultipleOf.IsSet() {
		toSerialize["multipleOf"] = o.MultipleOf.Get()
	}
	if o.Maximum.IsSet() {
		toSerialize["maximum"] = o.Maximum.Get()
	}
	if o.Minimum.IsSet() {
		toSerialize["minimum"] = o.Minimum.Get()
	}
	if o.MaxLength.IsSet() {
		toSerialize["maxLength"] = o.MaxLength.Get()
	}
	if o.MinLength.IsSet() {
		toSerialize["minLength"] = o.MinLength.Get()
	}
	if o.Pattern.IsSet() {
		toSerialize["pattern"] = o.Pattern.Get()
	}
	if !IsNil(o.MaxItems) {
		toSerialize["maxItems"] = o.MaxItems
	}
	if !IsNil(o.MinItems) {
		toSerialize["minItems"] = o.MinItems
	}
	if !IsNil(o.UniqueItems) {
		toSerialize["uniqueItems"] = o.UniqueItems
	}
	if !IsNil(o.MaxProperties) {
		toSerialize["maxProperties"] = o.MaxProperties
	}
	if !IsNil(o.MinProperties) {
		toSerialize["minProperties"] = o.MinProperties
	}
	if !IsNil(o.XDeprecated) {
		toSerialize["x-deprecated"] = o.XDeprecated
	}
	if o.XDeprecatedMessage.IsSet() {
		toSerialize["x-deprecatedMessage"] = o.XDeprecatedMessage.Get()
	}
	if !IsNil(o.XAbstract) {
		toSerialize["x-abstract"] = o.XAbstract
	}
	if o.XNullable.IsSet() {
		toSerialize["x-nullable"] = o.XNullable.Get()
	}
	if o.XExample != nil {
		toSerialize["x-example"] = o.XExample
	}
	if !IsNil(o.XEnumFlags) {
		toSerialize["x-enumFlags"] = o.XEnumFlags
	}
	if !IsNil(o.XDictionaryKey) {
		toSerialize["x-dictionaryKey"] = o.XDictionaryKey
	}
	if !IsNil(o.Xml) {
		toSerialize["xml"] = o.Xml
	}
	if !IsNil(o.Not) {
		toSerialize["not"] = o.Not
	}
	if o.ExclusiveMaximum != nil {
		toSerialize["exclusiveMaximum"] = o.ExclusiveMaximum
	}
	if o.ExclusiveMinimum != nil {
		toSerialize["exclusiveMinimum"] = o.ExclusiveMinimum
	}
	if o.AdditionalItems != nil {
		toSerialize["additionalItems"] = o.AdditionalItems
	}
	if o.AdditionalPropertiesField != nil {
		toSerialize["additionalProperties"] = o.AdditionalPropertiesField
	}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if !IsNil(o.Required) {
		toSerialize["required"] = o.Required
	}
	if !IsNil(o.Properties) {
		toSerialize["properties"] = o.Properties
	}
	if !IsNil(o.PatternProperties) {
		toSerialize["patternProperties"] = o.PatternProperties
	}
	if !IsNil(o.Definitions) {
		toSerialize["definitions"] = o.Definitions
	}
	if !IsNil(o.XEnumNames) {
		toSerialize["x-enumNames"] = o.XEnumNames
	}
	if !IsNil(o.Enum) {
		toSerialize["enum"] = o.Enum
	}
	if !IsNil(o.AllOf) {
		toSerialize["allOf"] = o.AllOf
	}
	if !IsNil(o.AnyOf) {
		toSerialize["anyOf"] = o.AnyOf
	}
	if !IsNil(o.OneOf) {
		toSerialize["oneOf"] = o.OneOf
	}
	if !IsNil(o.Ref) {
		toSerialize["$ref"] = o.Ref
	}

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return toSerialize, nil
}

func (o *JsonSchema) UnmarshalJSON(data []byte) (err error) {
	varJsonSchema := _JsonSchema{}

	err = json.Unmarshal(data, &varJsonSchema)

	if err != nil {
		return err
	}

	*o = JsonSchema(varJsonSchema)

	additionalProperties := make(map[string]interface{})

	if err = json.Unmarshal(data, &additionalProperties); err == nil {
		delete(additionalProperties, "$schema")
		delete(additionalProperties, "id")
		delete(additionalProperties, "title")
		delete(additionalProperties, "type")
		delete(additionalProperties, "discriminator")
		delete(additionalProperties, "description")
		delete(additionalProperties, "format")
		delete(additionalProperties, "default")
		delete(additionalProperties, "multipleOf")
		delete(additionalProperties, "maximum")
		delete(additionalProperties, "minimum")
		delete(additionalProperties, "maxLength")
		delete(additionalProperties, "minLength")
		delete(additionalProperties, "pattern")
		delete(additionalProperties, "maxItems")
		delete(additionalProperties, "minItems")
		delete(additionalProperties, "uniqueItems")
		delete(additionalProperties, "maxProperties")
		delete(additionalProperties, "minProperties")
		delete(additionalProperties, "x-deprecated")
		delete(additionalProperties, "x-deprecatedMessage")
		delete(additionalProperties, "x-abstract")
		delete(additionalProperties, "x-nullable")
		delete(additionalProperties, "x-example")
		delete(additionalProperties, "x-enumFlags")
		delete(additionalProperties, "x-dictionaryKey")
		delete(additionalProperties, "xml")
		delete(additionalProperties, "not")
		delete(additionalProperties, "exclusiveMaximum")
		delete(additionalProperties, "exclusiveMinimum")
		delete(additionalProperties, "additionalItems")
		delete(additionalProperties, "additionalProperties")
		delete(additionalProperties, "items")
		delete(additionalProperties, "required")
		delete(additionalProperties, "properties")
		delete(additionalProperties, "patternProperties")
		delete(additionalProperties, "definitions")
		delete(additionalProperties, "x-enumNames")
		delete(additionalProperties, "enum")
		delete(additionalProperties, "allOf")
		delete(additionalProperties, "anyOf")
		delete(additionalProperties, "oneOf")
		delete(additionalProperties, "$ref")
		o.AdditionalProperties = additionalProperties
	}

	return err
}

type NullableJsonSchema struct {
	value *JsonSchema
	isSet bool
}

func (v NullableJsonSchema) Get() *JsonSchema {
	return v.value
}

func (v *NullableJsonSchema) Set(val *JsonSchema) {
	v.value = val
	v.isSet = true
}

func (v NullableJsonSchema) IsSet() bool {
	return v.isSet
}

func (v *NullableJsonSchema) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJsonSchema(val *JsonSchema) *NullableJsonSchema {
	return &NullableJsonSchema{value: val, isSet: true}
}

func (v NullableJsonSchema) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJsonSchema) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
